public class Probleme1
{
    public static void main(String[] args) throws Exception
    {
        // Programme qui ajoute les elements de t2 dans t1 en
        //  conservant l'ordre croissant
        //
        int[] t1 = {5,5,10,10,20,0,0,0,0,0,0,0,0};
        int[] t2   = {5,3,23,2};
        ajouterTabOrd( t1, 5, t2, 4);   

        //Vrification du rsultat
        for(int i=0;i<9;i++)
            System.out.println(t1[i]);
        System.out.println("---------------");

        // Test de t1 vide
        ajouterTabOrd( t1, 0, t2, 4);   

        //Vrification du rsultat
        for(int i=0;i<4;i++)
            System.out.println(t1[i]);
        System.out.println("---------------");
        
        // Test de l'exception
        int[] tt1 = {5,5,10,10,20,0,0};
        int[] tt2   = {5,10,50};
        ajouterTabOrd( tt1, 5, tt2, 3);
    }

    // Ajoute t2 dans t1 en gardant l'ordre croissant de t1
    static public void ajouterTabOrd(int[] t1,
                              int nb1, 
                              int[] t2, 
                              int nb2) throws Exception
    {
        // Si t1 n'est pas assez grand alors exception
        if (t1.length < nb1 + nb2)
            throw new Exception("t1 pas assez grand");

        // Cas particulier : si t1 est vide
        /*
        if (nb1==0)
            {
                for(int i=0;i<nb1;i++)
                    t1[i] = t2[i];
                return;
            }
        */

        // Pour chaque element de t2
        for(int p=0;p<nb2;p++)
            {
                // On recherche le 1er element immediatement superieur
                boolean ajoute=false;
                for(int i=0;i<nb1;i++)
                    {
                        if(t1[i]>t2[p])
                            {
                                // On dcale pour insrer le nouvel lment
                                for(int k=nb1;k>=i;k--)
                                    t1[k+1]=t1[k];
                                t1[i]=t2[p];
                                nb1++;
                                ajoute=true;
                                break;
                            }
                    }
                // Si on n'a pas trouv de 1er element immediatement superieur
                // alors il fat ajouter le nouvel element  la fin de t1
                if (!ajoute)
                    {
                        t1[nb1]=t2[p];
                        nb1++;
                    }
            }
    }
}
