import java.util.*;

public class Probleme3
{
    public static void main(String[] args)
    {
        // Lecture du fichier et recupration de chacune des lignes dans un
        //  tableau de chaine
        StringBuffer sbf = Terminal.lireFichier("CompteBancaire.txt");
        String[] lignes = sbf.toString().split("\n");
        
        // Les valeurs  calculer
        double solde=0.0;      // Solde du compte
        double somme_cb=0.0;   // Somme des CB
        double somme_ch=0.0;   // Somme des chques
        String[] origine_prlvt = new String[100];  // Le nom d'une origine de prlvt
        double[] valeur_prlvt  = new double[100];  // La somme des prlvt d'une origine
        int      nb_prlvt = 0;  // Nb d'origine de prlvt

        // Parcours des lignes
        for(int i=0;i<lignes.length;i++)
            {
                // Rcupration de chacun des mots de la ligne dans une
                //   StringTokenizer
                StringTokenizer strtok=new StringTokenizer(lignes[i]);

                // Si 1ere ligne alors c'est le solde initial du compte
                if(i==0)
                    {
                        strtok.nextToken();  // On saute le mot SOLDE
                        solde = Double.parseDouble(strtok.nextToken());
                    }
                else
                    {
                        // On rcupre les 3 lments de la ligne
                        String elt1 = strtok.nextToken();
                        String elt2 = strtok.nextToken();
                        String elt3 = strtok.nextToken();

                        // Valeur de la transaction
                        double val = Double.parseDouble(elt3);
                        
                        // Si un DEBIT de CB ou Chque
                        if (elt1.equals("DEBIT"))
                            {
                                if (elt2.equals("CB"))
                                    somme_cb=somme_cb-val;
                                else
                                    somme_ch=somme_ch-val;
                                solde=solde-val;
                            }
                        // Si un CREDIT de CB ou Chque
                        if (elt1.equals("CREDIT"))
                            {
                                if (elt2.equals("CB"))
                                    somme_cb=somme_cb+val;
                                else
                                    somme_ch=somme_ch+val;
                                solde=solde+val;
                            }
                        // Si un Prlvement
                        if (elt1.equals("PRLVT"))
                            {
                                // On recherche si on n'a pas dj rencontr
                                //  cette origine de prlvt 
                                int indice = -1;
                                for(int k=0;k<nb_prlvt;k++)
                                    if (origine_prlvt[k].equals(elt2))
                                        indice=k;
                                // Si non trouv l'origine
                                if(indice==-1)
                                    {
                                        // On mmorise l'origine et sa somme initial
                                        origine_prlvt[nb_prlvt]=elt2;
                                        valeur_prlvt[nb_prlvt]=val;
                                        nb_prlvt++;
                                        solde=solde-val;
                                    }
                                else
                                    {
                                        // On incrmente la somme de l'origine
                                       valeur_prlvt[indice] =
                                           valeur_prlvt[indice]+val;
                                       solde=solde-val;
                                    }
                            }
                    }
            }
        // Affichage des informations calcules
        System.out.println("Solde final = "+solde);
        System.out.println("Detail CB   = "+somme_cb);
        System.out.println("Detail CH   = "+somme_ch);
        for(int i=0;i<nb_prlvt;i++)
            System.out.println("PLVT "+
                               origine_prlvt[i]+" "+
                               valeur_prlvt[i]);
    }
}
